-- start query 4 in stream 0 using template query44.tpl
select  asceding.rnk, i1.i_product_name best_performing, i2.i_product_name worst_performing
from(select *
     from (select item_sk,rank() over (order by rank_col asc) rnk
           from (select ss_item_sk item_sk,avg(ss_net_profit) rank_col 
                 from bigdata_public_dataset.tpcds_1g.store_sales ss1
                 where ss_store_sk = 429
                 group by ss_item_sk
                 having avg(ss_net_profit) > 0.9*(select avg(ss_net_profit) rank_col
                                                  from bigdata_public_dataset.tpcds_1g.store_sales
                                                  where ss_store_sk = 429
                                                    and ss_addr_sk is null
                                                  group by ss_store_sk))V1)V11
     where rnk  < 11) asceding,
    (select *
     from (select item_sk,rank() over (order by rank_col desc) rnk
           from (select ss_item_sk item_sk,avg(ss_net_profit) rank_col
                 from bigdata_public_dataset.tpcds_1g.store_sales ss1
                 where ss_store_sk = 429
                 group by ss_item_sk
                 having avg(ss_net_profit) > 0.9*(select avg(ss_net_profit) rank_col
                                                  from bigdata_public_dataset.tpcds_1g.store_sales
                                                  where ss_store_sk = 429
                                                    and ss_addr_sk is null
                                                  group by ss_store_sk))V2)V21
     where rnk  < 11) descending,
bigdata_public_dataset.tpcds_1g.item i1,
bigdata_public_dataset.tpcds_1g.item i2
where asceding.rnk = descending.rnk 
  and i1.i_item_sk=asceding.item_sk
  and i2.i_item_sk=descending.item_sk
order by asceding.rnk
limit 100;

-- end query 4 in stream 0 using template query44.tpl
